#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Sample applet for gnome
import pygtk
#pygtk.require('2.0')
import sys
import gtk
import gnome.ui
import gnomeapplet
import os.path
import urllib
import xml.dom.minidom
#import codecs
import pynotify
import datetime
import gobject
import Preference

#import sys
#out = open('/home/vanuch/log.txt', 'w+')
#outerr = open('/home/vanuch/logerr.txt', 'w+')
#sys.stdout = out
#sys.stderr = outerr
#print "test"


#config env
#theme='Blue' #black_theme or blue_theme
path = '/home/vanuch/python/forismatic/'  #folder with files
#theme_path=os.path.abspath(path)
#theme_path=os.path.join(theme_path,'Themes')
#theme_path=os.path.join(path,'Themes',theme)
#print theme_path
#time=30*60  #period between quotes(min*60sec)

__version__ = "0.5"
__license__ = "GNU General Public License v.2"
__author__ = "Vanuch <goncharov.ivan.v@gamil.com>"


class GnomeAppletSkeleton(gnomeapplet.Applet):
    """Simple applet skeleton
		author Pythy <the.pythy@gmail.com>
	"""

    def __init__(self, applet, iid):
        """Create applet for proxy"""
        self.applet = applet
        self.__init_core_widgets()
        self.init_additional_widgets()
        self.init_ppmenu()
        self.__connect_events()
        self.applet.connect("destroy", self._cleanup)
        self.after_init()
        self.applet.show_all()

    def __init_core_widgets(self):
        """Create internal widgets"""
        # making internal widgets
        self.tooltip = gtk.Tooltip() #self.tooltips = gtk.Tooltips()
        self.hbox = gtk.HBox()
        self.ev_box = gtk.EventBox()
        # making widgets' ierarchy
        self.applet.add(self.hbox)
        self.hbox.add(self.ev_box)

    def init_additional_widgets(self):
		"""Create additional widgets"""
		self.image=gtk.Image()
		self.cur_dir=os.path.abspath(path)
		self.cur_dir=os.path.join(self.cur_dir,'Theme/Blue')
		self.icon_path=\
		os.path.join(self.cur_dir,'forismatic_icon_16.png')
		self.image.set_from_file(self.icon_path)
		self.ev_box.add(self.image)

    def init_ppmenu(self):
        """Create popup menu for properties"""
        self.ppmenu_xml = """
        <popup name="button3">
        <menuitem name="About Item" verb="About" stockid="gtk-about"/>
        </popup>        
        """
        self.ppmenu_verbs = [("About", self.on_ppm_about),
            ]

    def __connect_events(self):
        """Connect applet's events to callbacks"""
        self.ev_box.connect("button-press-event", self.on_button)
        self.ev_box.connect("enter-notify-event", self.on_enter)
        self.button_actions = {
            1: lambda: None,  
            2: lambda: None,
            3: self._show_ppmenu,
            }

    def after_init(self):
        """After-init hook"""
        pass

    def _cleanup(self, event):
        """Cleanup callback (on destroy)"""
        del self.applet

    def on_button(self, widget, event):
        """Action on pressing button in applet"""
        if event.type == gtk.gdk.BUTTON_PRESS:
			self.button_actions[event.button]()

    def _show_ppmenu(self):
        """Show popup menu"""
        print self.applet.setup_menu.__doc__
        self.applet.setup_menu(self.ppmenu_xml,
                               self.ppmenu_verbs,
                               None)

    def on_enter(self, widget,event):
		"""Action on entering mouse to widget"""
		self.info = "PopUp info" 
		self.ev_box.set_tooltip_text(str(self.info)) 
        

    def on_ppm_about(self, event, data=None):
        """Action on chose 'about' in pop-up menu"""
        gnome.ui.About("GnomeApplet skeleton", "0.1", 
					   "GNU General Public License v.2",
                       "Simple skeleton for Python powered GNOME applet",
                       ["Pythy <the.pythy@gmail.com>",],
                       ).show()
                       
		
class Forismatic:
	"""Return random quote form www.forismatic.com"""
	def __init__(self, conf):
		#self.theme_path = theme_path
		self.conf = conf
		
		
	def get_quote(self):
		cur_dir=os.path.abspath(path)
		#saved_quote_path=os.path.join(cur_dir, 'forismatic') # if quote write to file
		(self.TimePeriod, self.Theme) = self.conf.get_settings()
		self.theme_path = os.path.join(path,'Themes',self.Theme)
		logo_path=os.path.join(self.theme_path,'forismatic_logo48x48.png')
		#print logo_path
		#0) read file with saved quote
		"""with codecs.open(saved_quote_path,
						encoding='utf-8',mode='r') as file_r:
			quote = file_r.readlines()
		file_r.closed
		quote=u"".join(quote)
		"""
		#read from GConf
		(self.QuoteText,self.quoteAuthor,self.QuoteLink)=self.conf.get_Quote()
		#print "%s  \n   %s :: %s"%(self.QuoteText,self.quoteAuthor,self.QuoteLink)
		if self.quoteAuthor == "":
			quote=self.QuoteText
		else:
			quote=self.QuoteText+"\n"+self.quoteAuthor
		#print quote
		#0.5) print Notify
		title='Forismatic'
		body=quote
		icon='file://'+logo_path
		notif = pynotify.Notification (title, body, icon);
		notif.show ()
		#1)get quote form forismatic
		#exampl of quote:
		"""
		<forismatic>
			<quote>
				<quoteText>
					Для любви не существует вчера, любовь не думает \
					о завтра. 
					Она жадно тянется к нынешнему дню, но этот день \
					нужен ей весь, неограниченный, не омраченный. 
				</quoteText>
				<quoteAuthor>
					Генрих Гейне 
				</quoteAuthor>
				<senderName>
				</senderName>
				<senderLink>
					http://ru.forismatic.com/8d9098bc35/
				</senderLink>
				<quoteLink>
					http://ru.forismatic.com/13d15ebb9a/
				</quoteLink>
			</quote>
		</forismatic>
		"""
		#TODO: add check of bad response
		params = urllib.urlencode({'method': 'getQuote',
		 'format': 'xml', 'lang': 'ru'})
		f =urllib.urlopen("http://www.forismatic.com/api/1.0/" , params)
		quote_xml = f.read()
		#2)parseQuote:
		quoteText = "can not get quote"
		quoteAuthor = ""
		quoteLink = "error"
		
		quote=xml.dom.minidom.parseString(quote_xml)
		#text
		text = quote.getElementsByTagName('quoteText')
		for node in text[0].childNodes:
			if node.nodeType == node.TEXT_NODE:
				quoteText=node.data
		#author		
		text = quote.getElementsByTagName('quoteAuthor')
		for node in text[0].childNodes:
			if node.nodeType == node.TEXT_NODE:
				quoteAuthor =node.data
				quoteAuthor = "--"+ quoteAuthor
				quoteAuthor = quoteAuthor.rjust(30," ")
		#link							
		text = quote.getElementsByTagName('quoteLink')
		for node in text[0].childNodes:
			if node.nodeType == node.TEXT_NODE:
				quoteLink =node.data
		#write to file			
		"""with codecs.open(saved_quote_path, 
						encoding='utf-8',mode='w') as file_w:
			file_w.write(quoteText)
			file_w.write("\n"+quoteAuthor)
		file_w.closed"""
		#write to GConf
		self.conf.set_Quote(quoteText, quoteAuthor, quoteLink)


class GnomeForismaticApplet(GnomeAppletSkeleton):
	def __init__(self, applet, iid):
		#print applet
		self.applet=applet
		self.iid=iid
		self.conf = Preference.Config(applet,self.cb_TimePeriod,self.cb_Theme)
		(self.TimePeriod, self.Theme) = self.conf.get_settings()
		self.theme_path = os.path.join(path,'Themes',self.Theme)
		#print self.theme_path
		self.time = self.TimePeriod*60
		#print self.time
		if self.time==0:
			self.time = 300
		GnomeAppletSkeleton.__init__(self, applet, iid)
	
	def init_additional_widgets(self):
		"""Create additional widgets"""
		self.icon_path=\
		os.path.join(self.theme_path,'forismatic_icon_16.png')
		self.pixbuff = gtk.gdk.pixbuf_new_from_file(self.icon_path)
		self.image=gtk.Image()
		print "thme path from init_add_widgets func: %s"%self.theme_path
		self.image.set_from_pixbuf(self.pixbuff)
		self.ev_box.add(self.image)
	
	def after_init(self):
		self.quote=Forismatic(self.conf)
		self.button_actions[1]=self.show_quote
		self.timer()
	
	def on_enter(self, widget,event):
		try:
			self.delta_time=datetime.datetime.today()-self.start_timer
			self.left_time=self.time-self.delta_time.seconds
			self.delta_time_norm=\
			datetime.timedelta(seconds=self.delta_time.seconds)
			self.left_time_norm=\
			datetime.timedelta(seconds=self.left_time)
			self.info="Last quote was %s ago\n Next quote after %s" %\
			(self.delta_time_norm,self.left_time_norm)
			#print "on enter notif: %s"%self.info
		except :
			self.info = "Forismatic" 
		self.ev_box.set_tooltip_text(str(self.info)) 
					
	def handler(self):
		self.quote.get_quote()
		self.start_timer=datetime.datetime.today()
		return True
		
	def timer(self):
		(self.TimePeriod, self.Theme) = self.conf.get_settings()
		self.time=self.TimePeriod*60
		self.source_event=\
		gobject.timeout_add_seconds(self.time, self.handler)
		self.start_timer=datetime.datetime.today()
				
	def show_quote(self):
		#print 'show quote'
		gobject.source_remove(self.source_event)
		self.quote.get_quote()
		self.timer()
		
	def on_ppm_about(self, event, data=None):
		"""Callback for pop-up menu item 'About', show About dialog"""
		self.icon_path=\
		os.path.join(self.theme_path,'forismatic_icon_100.png')
		self.pixbuf=gtk.gdk.pixbuf_new_from_file(self.icon_path)
		msg_applet_name = u"Forismatic Notify"
		msg_applet_description = \
		u"Forismatic applet for Python powered GNOME applet"
		gnome.ui.About(msg_applet_name, __version__, __license__,
					   msg_applet_description,
					   [__author__,],   # programming
						None,   # documentation
						None,   # translating
						self.pixbuf,
					   ).show()
	
	def init_ppmenu(self):
		"""Create popup menu for properties"""
		self.ppmenu_xml = """
		<popup name="button3">
			<menuitem name="ItemPreferences" 
				verb="Preferences" 
				label="_Preferences" 
				pixtype="stock" 
				pixname="gtk-preferences"/>
			<separator/>
			<menuitem name="About Item" 
				verb="About"
				label=" About"
				pixtype="stock" 
				stockid="gtk-about"/>
		</popup> """
		self.ppmenu_verbs = [("About", self.on_ppm_about),
							 ('Preferences', self.show_preferences)
							]
	
	def show_preferences(self,*arguments):
		print (arguments)
		self.pref = Preference.Preference(self.applet, path)
			
	def cb_TimePeriod(self,client, cnxn_id, entry, params):
		self.TimePeriod = self.conf.get_settings()[0]
		print self.TimePeriod
	
	def cb_Theme(self,client, cnxn_id, entry, params):
		self.Theme = self.conf.get_settings()[1]
		print self.Theme
		self.theme_path = os.path.join(path,'Themes',self.Theme)
		self.icon_path=\
		os.path.join(self.theme_path,'forismatic_icon_16.png')
		self.pixbuff = gtk.gdk.pixbuf_new_from_file(self.icon_path)
		self.image.set_from_pixbuf(self.pixbuff)
		


def applet_factory(applet, iid):
	GnomeForismaticApplet(applet, iid)
	return True
    

def run_in_panel():
    gnomeapplet.bonobo_factory("OAFIID:GNOME_ForismaticNotify_Factory",
                               GnomeForismaticApplet.__gtype__,
                               "Applet Forismatic Notify",
                               "0",
                               applet_factory)
                               

def run_in_window():
    main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    main_window.set_title("GNOME Applet Forismatic")
    main_window.connect("destroy", gtk.main_quit)
    app = gnomeapplet.Applet()
    applet_factory(app, None)
    app.reparent(main_window)
    main_window.show_all()
    gtk.main()
    sys.exit()
    

def main(args):
    if len(args) == 2 and args[1] == "run-in-window":
        run_in_window()
    else:
        run_in_panel()
        

if __name__ == '__main__':
    main(sys.argv)
